/* This file is part of guile-with-graphics, a graphic library for Guile

Copyright (C) 2008  Luca Saiu
Updated in 2009 and 2010 by Luca Saiu
Based on turtle, by Luca Saiu

This program is free software: you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation, either version 3 of the License, or
(at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program.  If not, see <http://www.gnu.org/licenses/>. */


#ifndef GUILESDL_H_
#define GUILESDL_H_

/* Initialize Guile and start the REPL, so that the user can play with
   graphic primitives and events. It is not possible to exit the
   REPL without exiting the whole program. */
void game_initialize_guile_and_start_the_repl(int argc,
                                              char **argv);

/* Initialize Guile and make it run the given C function: */
void game_initialize_guile_and_call(int argc,
                                    char **argv,
                                    void (*f)(int argc, char **argv));

#endif // #ifndef GUILESDL_H_
