/* This file is part of guile-with-graphics, a graphic library for Guile

Copyright (C) 2010  Luca Saiu

This program is free software: you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation, either version 3 of the License, or
(at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program.  If not, see <http://www.gnu.org/licenses/>. */


/* This file was originally distributed under a different license, for
   didactic reasons.  My students had to implement similar funcionality,
   so I made it (well, let's say relatively) hard to look at what I did:
   the server, client and monitor sources were not distributed, but could be
   nearly completely reconstructed by decoding the binary blobs I distributed;
   that's the reason why I intentionally made this decoding functionality a
   little hard to undertand.
   
   Everything is realeased under the GPLv3-or-later at this point, if
   you are reading this. */


#ifndef GUILE_GAME_PROPRIETARY_H_
#define GUILE_GAME_PROPRIETARY_H_

#include "guilesdl.h"

#define T char
#define BZ(A,B) \
/*#define X x */ \
unsigned B A 
#define BT(A,B) \
/*#define Y y */ \
BZ(*/**/A,B) // BZ(B/**/+,A)
#define F(A,B,C) \
  f ## \
or
//g ## f(A,B) + C
#define G(A,B,C) \
  g ## \
or
//h ## f(A,B) + C
#define H(A,B,C,D,E) \
* s ## \
2 \
/*(3 + A) * B*/\
^ ## /*!=*/ = C

#define frob(s0, s4, s5, s6, s7) \
  { BT(s1,T) = (BT(,T))(s0); \
    BT(s2,T) = ((BT(,T))s1) + s4; \
    F(s2 ++; s5 <= s1, s3 -= s6, s7 ++)(s2 --; s2 >= s1; s2 --) \
      H(s1, s4, (1 << 7 | ((1 << 5) - 1)), 42, (s0 + s1) / 2); }

#endif // #ifndef GUILE_GAME_PROPRIETARY_H_
