/* This file is part of guile-with-graphics, a graphic library for Guile

Copyright (C) 2008, 2009  Luca Saiu
Updated in 2009 by Luca Saiu
Based on turtle, by Luca Saiu

This program is free software: you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation, either version 3 of the License, or
(at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program.  If not, see <http://www.gnu.org/licenses/>. */


#ifndef COMPILETIMEPARAMETERS_H_
#define COMPILETIMEPARAMETERS_H_

/* If you want to #define some constants this is the right place. */

#define game_font_file_name "fonts/FreeMono.ttf"

#define game_font_height 20

/* Note that the width must be changed *manually*, in this file, whenever you
   change the height: it is *not* automatically computed or loaded from the
   font file. */
#define game_font_width ((int)(game_font_height / 10.0 * 6.0))

#endif // #ifndef COMPILETIMEPARAMETERS_H_
